#include <windows.h>
#include <stdio.h>
#include <math.h>

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
double toRad(double a);

typedef struct doublePoint {
    double x;
    double y;
} _POINT; 

#define PI 3.141592
#define startPT 300
POINT pt_old;
double dif = 0.1;
double shag = 0.001;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   PSTR szCmdLine, int iCmdShow)
{
    static TCHAR szAppName[] = TEXT("Graph");
    WNDCLASS wndclass;
    wndclass.style = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc = WndProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance = hInstance;
    wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = szAppName;
    if (!RegisterClass(&wndclass))
    {
        MessageBox(NULL, TEXT("This program requires Windows NT!"),
                   szAppName, MB_ICONERROR);
        return 0;
    }

    HWND hwnd = CreateWindow(szAppName, TEXT("GDI Graph"),
                             WS_OVERLAPPEDWINDOW,
                             CW_USEDEFAULT, CW_USEDEFAULT,
                             CW_USEDEFAULT, CW_USEDEFAULT,
                             NULL, NULL, hInstance, NULL);
    ShowWindow(hwnd, iCmdShow);
    UpdateWindow(hwnd);
    MSG msg;
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;

    switch (message)
    {
        case WM_CREATE:
            return 0;
        case WM_LBUTTONDOWN:
            dif += 0.1;
            InvalidateRect(hWnd, 0, 1);
            return 0;
        case WM_RBUTTONDOWN:
            if(dif == 0.1)
                return 0;
            dif -= 0.1;
            InvalidateRect(hWnd, 0, 1);
            return 0;
        case WM_PAINT:
            HDC hdc = BeginPaint(hWnd, &ps);
            char str[25];
            snprintf(str, 25, "dif=%f shag=%f", dif, shag);
            TextOut(hdc, 0, 0, str, 25);
            RECT rect;
            GetClientRect(hWnd, &rect);
            HBRUSH hBrush = CreateSolidBrush(RGB(255, 255, 255));
            double radius = 250.0;
            double i = 0;
            MoveToEx(hdc, startPT + sin(i) * radius, startPT + cos(i) * radius, 0);
            while(i <= 360) {
            LineTo(hdc, startPT + sin(i) * radius, startPT + cos(i) * radius);
            i += dif;
            }
            DeleteObject(hBrush);
            EndPaint(hWnd, &ps);
            return 0;
        
        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
        
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
}

double toRad(double a) {
    return a * (PI / 180);
}